

var Util = {

    deepCopy: function (obj) {
        if (Object.prototype.toString.call(obj) === '[object Array]') {
            var out = [], i = 0, len = obj.length;
            for ( ; i < len; i++ ) {
                out[i] = arguments.callee(obj[i]);
            }
            return out;
        }
        if (typeof obj === 'object') {
            var out = {}, i;
            for ( i in obj ) {
                out[i] = arguments.callee(obj[i]);
            }
            return out;
        }
        return obj;
    },
    
    stringByteLength: function (inString) {
    
        // Return length of the UTF8 string in bytes
        if (Buffer) {
            return Buffer.byteLength(inString, 'utf8'); // Node
        } else {
            throw 'implement me'; // Browser
        }
        
    },
    
    round: function (inNum, inDecPlaces) {
    
        var m = Math.pow(10, inDecPlaces);
    
        return Math.round(inNum * m) / m;
    
    },
 
    pad: function (inString, inLength, inPadding) {
    
        // Single character padding only
        // inLength is character length, not byte length
        
        inString = '' + inString;
        inPadding = inPadding.substr(0,1); // First char only if >1 passed
        var n = inLength - inString.length;
        return (new Array(n + 1)).join(inPadding) + inString;
    
    }
     
};
    
    
    
    
    
    
// Module
module.exports = Util;